unit frmPandaTrayU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TntExtCtrls, unit_tasktray,
  Menus, TntMenus, TrackBox, ComCtrls, TntComCtrls,
  IniFiles, NewCtrls, CsvUtils2, AppEvnts, HotKeyManager, shellapi, unit_geticon,
  Buttons, TntButtons, ShlObj, ActiveX, ComObj, TntDialogs, TntStdCtrls;


const
  F_ID         = 0;
  F_NAME       = 1;
  F_FILENAME   = 2;
  F_COUNT      = 3;
  F_DATE       = 4;
  F_ICONOLD    = 5;
  F_ICON       = 6;

  VERSION   = 'Version 1.016';
  S_CAPTION = '[PT]';
  MSG_ABOUT = '[Panda Tray 5]'#13#10+VERSION;
  msg_exec_failed = 'sɎs܂B';

  FILE_LIST = 'data\applist.tsv';
  FILE_MEMO = 'data\memo.txt';

  DIR_DATA = 'data\';
  DIR_ICON = 'icon\';

  FILE_STARTUP = 'PandaTray5.lnk';
  FILE_README  = 'readme.txt';

  INI_SEC_HOTKEY  = 'hotkey';
  INI_KEY_MOVECUR = 'movecur';
  INI_KEY_MOVEWIN = 'movewin';
  INI_KEY_SHOW    = 'show';
  INI_KEY_RESTART = 'restart_self';

  ICON_DIR = 'icons\';

(* memo:

Screen.Monitors[x]Ńj^[̃vpeB擾
TMonitor`FbN

*)


type
  TPandaSortType = (stTime, stCount, stName);

  TfrmPandaTray = class(TForm)
    panelCommand: TTntPanel;
    edtCommand: TTntEdit;
    popsMain: TTntPopupMenu;
    popCompleteClose: TTntMenuItem;
    N1: TTntMenuItem;
    popClose: TTntMenuItem;
    popOpen: TTntMenuItem;
    N2: TTntMenuItem;
    fileDrop: TFileDrop;
    lstMain: TListBox;
    AppEvent: TApplicationEvents;
    popsFile: TTntPopupMenu;
    popEditItem: TTntMenuItem;
    popAddItem: TTntMenuItem;
    popInstall: TTntMenuItem;
    N3: TTntMenuItem;
    popAbout: TTntMenuItem;
    N4: TTntMenuItem;
    popHelp: TTntMenuItem;
    N6: TTntMenuItem;
    popHotKeyChange: TTntMenuItem;
    popOpenSetDir: TTntMenuItem;
    imgDefIcon: TImage;
    popDelItem: TTntMenuItem;
    N7: TTntMenuItem;
    N5: TTntMenuItem;
    popCheckAndRemove: TTntMenuItem;
    N8: TTntMenuItem;
    N9: TTntMenuItem;
    btnConf: TTntSpeedButton;
    popUninstall: TTntMenuItem;
    timerPanel: TTimer;
    imgIconTray: TImage;
    N10: TTntMenuItem;
    N11: TTntMenuItem;
    popExecWithArg: TTntMenuItem;
    popExecWithArgFile: TTntMenuItem;
    popExecWithArgStr: TTntMenuItem;
    dlgOpen: TTntOpenDialog;
    N12: TTntMenuItem;
    popLaunchEditNote: TTntMenuItem;
    N13: TTntMenuItem;
    popChangeTrayIcon: TTntMenuItem;
    N14: TTntMenuItem;
    popSortName: TTntMenuItem;
    popSortTime: TTntMenuItem;
    popSortCount: TTntMenuItem;
    popMultiMonitor: TTntMenuItem;
    popHotKeyMoveCur: TTntMenuItem;
    popHotkeyMoveWin: TTntMenuItem;
    imgWebIcon: TImage;
    mnuOpenTargetDir: TTntMenuItem;
    mnuRestartLaunch: TTntMenuItem;
    popHotkeyRestart: TTntMenuItem;
    mnuClearIconCache: TTntMenuItem;
    N15: TTntMenuItem;
    mnuOpenSendTo: TTntMenuItem;
    mnuOpenCalc: TTntMenuItem;
    mnuPandaTrayWeb: TTntMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure panelCommandResize(Sender: TObject);
    procedure popCloseClick(Sender: TObject);
    procedure popsMainPopup(Sender: TObject);
    procedure popCompleteCloseClick(Sender: TObject);
    procedure popOpenClick(Sender: TObject);
    procedure fileDropFileDrop(Sender: TObject; Num: Integer;
      Files: TStrings; X, Y: Integer);
    procedure AppEventDeactivate(Sender: TObject);
    procedure edtCommandChange(Sender: TObject);
    procedure edtCommandKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnConfClick(Sender: TObject);
    procedure popInstallClick(Sender: TObject);
    procedure popEditItemClick(Sender: TObject);
    procedure lstMainDblClick(Sender: TObject);
    procedure lstMainMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure popAboutClick(Sender: TObject);
    procedure popAddItemClick(Sender: TObject);
    procedure popHelpClick(Sender: TObject);
    procedure popHotKeyChangeClick(Sender: TObject);
    procedure popOpenSetDirClick(Sender: TObject);
    procedure lstMainDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure lstMainKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure popDelItemClick(Sender: TObject);
    procedure popCheckAndRemoveClick(Sender: TObject);
    procedure lstMainKeyPress(Sender: TObject; var Key: Char);
    procedure popUninstallClick(Sender: TObject);
    procedure timerPanelTimer(Sender: TObject);
    procedure popExecWithArgFileClick(Sender: TObject);
    procedure popExecWithArgStrClick(Sender: TObject);
    procedure popLaunchEditNoteClick(Sender: TObject);
    procedure popChangeTrayIconClick(Sender: TObject);
    procedure popSortTimeClick(Sender: TObject);
    procedure popSortCountClick(Sender: TObject);
    procedure popSortNameClick(Sender: TObject);
    procedure popHotKeyMoveCurClick(Sender: TObject);
    procedure popHotkeyMoveWinClick(Sender: TObject);
    procedure edtCommandKeyPress(Sender: TObject; var Key: Char);
    procedure mnuOpenTargetDirClick(Sender: TObject);
    procedure mnuRestartLaunchClick(Sender: TObject);
    procedure popHotkeyRestartClick(Sender: TObject);
    procedure mnuClearIconCacheClick(Sender: TObject);
    procedure mnuOpenSendToClick(Sender: TObject);
    procedure mnuOpenCalcClick(Sender: TObject);
    procedure mnuPandaTrayWebClick(Sender: TObject);
  private
    { Private 錾 }
    hotkeyid_show,
    hotkeyid_movecur,
    hotkeyid_movewin,
    hotkeyid_restart: DWORD;
    procedure hotkeyShowHotKeyPressed(HotKey: Cardinal; Index: Word);
    procedure TrayOnLeftClick(Sender: TObject);
    procedure TrayOnRightClick(Sender: TObject);
    function Str2SortType(s: string): TPandaSortType;
    function getNextMonitor(CurPos: TPoint): TMonitor;
    function ExecCommandEx(cmd:string): Boolean; // TrueԂ
  protected
    procedure WndProc(var Message: TMessage); override;
  public
    { Public 錾 }
    bCanClose: Boolean;
    bTrayOpen: Boolean;
    tray: TKujiraTasktray;
    csvList: TCsvSheet;
    csvView: TCsvSheet;
    ini: TIniFile;
    Args: string;
    sortType: TPandaSortType;
    hotkeyShow: THotKeyManager;
    iconList: TList;
    procedure VariableInitialize;
    procedure VariableFinalize;
    procedure TrayHide;
    procedure TrayShow;
    procedure ListViewAll;
    procedure ListView;
    procedure ListExecute;
    procedure ListSave;
    procedure IconListClear;
  end;

var
  frmPandaTray: TfrmPandaTray;

implementation

uses gui_benri, wildcard, frmPropU, DirUtil, frmMemoU;


{$R *.dfm}



procedure TfrmPandaTray.VariableInitialize;
var
  key: Integer;
  s, fileIcon: string;
begin
  // todo: 
  hotkeyShow := THotKeyManager.Create(Self);
  hotkeyShow.OnHotKeyPressed := hotkeyShowHotKeyPressed;
  Application.Title := S_CAPTION;
  Caption := S_CAPTION;
  iconList := TList.Create;
  //
  bCanClose := True;
  bTrayOpen := False;
  sortType  := stTime;
  Args := '';
  ini := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));

  // gCACR̐ݒ
  fileIcon := ini.ReadString('icon','tasktray','');
  if fileIcon <> '' then
  begin
    try
      imgIconTray.Picture.LoadFromFile(fileIcon);
    except
    end;
  end;

  tray := TKujiraTasktray.Create(Self, 'PandaTray', imgIconTray.Picture.Icon);
  tray.OnLeftClick  := TrayOnLeftClick;
  tray.OnRightClick := TrayOnRightClick;
  tray.InitTasktray;

  //
  csvList := TCsvSheet.Create;
  csvView := TCsvSheet.Create;
  csvList.UseHeader := False;
  csvView.UseHeader := False;


  // HOTKEY.SHOW
  s   := ini.ReadString(INI_SEC_HOTKEY, INI_KEY_SHOW, 'Ctrl+Shift+Q');
  key := TextToHotKey(s, True);
  hotkeyid_show := hotkeyShow.AddHotKey(key);
  popHotKeyChange.Caption := 'NL[['+s+']̕ύX';

  // HOTKEY.MOVECUR
  s   := ini.ReadString(INI_SEC_HOTKEY, INI_KEY_MOVECUR, '');
  if s <> '' then
  begin
    key := TextToHotKey(s, True);
    hotkeyid_movecur := hotkeyShow.AddHotKey(key);
    popHotKeyMoveCur.Caption := 'J[\ړL[[' + s + ']̕ύX';
  end else
  begin
    hotkeyid_movecur := 0;
    popHotKeyMoveCur.Caption := 'J[\ړL[̐ݒ';
  end;
  // HOTKEY.MOVEWIN
  s   := ini.ReadString(INI_SEC_HOTKEY, INI_KEY_MOVEWIN, '');
  if s <> '' then
  begin
    key := TextToHotKey(s, True);
    hotkeyid_movewin := hotkeyShow.AddHotKey(key);
    popHotKeyMoveWin.Caption := 'ANeBuEBhEړL[[' + s + ']̕ύX';
  end else
  begin
    hotkeyid_movewin := 0;
    popHotKeyMoveWin.Caption := 'ANeBuEBhEړL[̐ݒ';
  end;
  // HOTKEY.RESTART
  s   := ini.ReadString(INI_SEC_HOTKEY, INI_KEY_RESTART, '');
  if s <> '' then
  begin
    key := TextToHotKey(s, True);
    hotkeyid_restart := hotkeyShow.AddHotKey(key);
    popHotkeyRestart.Caption := 'gċNL[[' + s + ']̕ύX';
  end else
  begin
    hotkeyid_restart := 0;
    popHotkeyRestart.Caption := 'gċNL[̐ݒ';
  end;

  // LOAD LIST
  if FileExists(AppPath + FILE_LIST) then
  begin
    csvList.LoadFromFile(AppPath + FILE_LIST, nil, #9);
    csvList.TrimBottom;
  end;

  // SORT
  s := ini.ReadString('launch','sort','time');
  sortType := Str2SortType(s);

  ListViewAll;

  // ͂߂āH
  if ini.ReadBool('flag','installed',False) = False then
  begin
    ForceDirectories(AppPath + ICON_DIR);
    ini.WriteBool('flag','installed',True);
    popInstallClick(nil);
  end;

end;

procedure TfrmPandaTray.FormCreate(Sender: TObject);
begin
  VariableInitialize;
  Application.ShowMainForm := False;
  panelCommandResize(nil);
end;

procedure TfrmPandaTray.VariableFinalize;
begin
  // todo: I
  IconListClear;
  FreeAndNil(iconList);
  FreeAndNil(tray);
  FreeAndNil(csvList);
  FreeAndNil(csvView);
  FreeAndNil(ini);
end;

procedure TfrmPandaTray.FormDestroy(Sender: TObject);
begin
  VariableFinalize;
end;

procedure TfrmPandaTray.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := bCanClose;
  if CanClose = False then
  begin
    TrayHide;
  end;
end;

procedure TfrmPandaTray.TrayHide;
begin
  // tH[̑傫ۑ
  ini.WriteInteger('frmPandaTray','Height',Self.Height);
  //
  Self.Hide;
  bCanClose := True;
  bTrayOpen := False;
  timerPanel.Enabled := False;
end;

procedure TfrmPandaTray.TrayShow;
var
  x, y: Integer;
  p: TPoint;
begin
  Application.BringToFront;
  Self.BringToFront;

  //
  Self.Height := ini.ReadInteger('frmPandaTray','Height',Self.Height);

  bCanClose := False;
  bTrayOpen := True;

  // }EẌʒu
  x := Mouse.CursorPos.X {- Self.Width div 2};
  y := Mouse.CursorPos.Y - Self.Height div 2;

  if (x + Self.Width) > Screen.WorkAreaRect.Right then
  begin
    x := Screen.WorkAreaRect.Right - Self.Width;
  end;
  if (y + Self.Height) > Screen.WorkAreaRect.Bottom then
  begin
    y := Screen.WorkAreaRect.Bottom - Self.Height;
  end else
  if y < Screen.WorkAreaTop then
  begin
    y := Screen.WorkAreaTop;
  end;

  Self.Left := x;
  Self.Top  := y;
  Self.Show;
  //
  ListView;

  // ܂ɃANeBuɂȂȂ̂ŁAtH[NbN
  // IɃANeBuɂ
  GetCursorPos(p);
  SetCursorPos(Self.Left+1, Self.Top + Self.Height-2);
  mouse_event(MOUSEEVENTF_LEFTDOWN, 0,0,0,0);
  mouse_event(MOUSEEVENTF_LEFTUP, 0,0,0,0);
  SetCursorPos(p.X, p.Y);
  //
  lstMain.ItemIndex := lstMain.Items.Count - 1;
  lstMain.SetFocus;
  edtCommand.SetFocus;
  //
  timerPanelTimer(nil);
  timerPanel.Enabled := True;
end;

procedure TfrmPandaTray.panelCommandResize(Sender: TObject);
begin
  edtCommand.Width  := panelCommand.ClientWidth - btnConf.Width - 4;
  btnConf.Left := edtCommand.Width + 2;
end;

procedure TfrmPandaTray.WndProc(var Message: TMessage);
var
  mw: TWMMouseWheel;
begin
  inherited;
  if tray <> nil then tray.WndProc(Message);

  if Message.Msg = WM_MOUSEWHEEL then
  begin
    Move(Message, mw, SizeOf(mw));
    if mw.WheelDelta > 0 then
    begin
      if lstMain.ItemIndex > 0 then
      begin
        lstMain.ItemIndex := lstMain.ItemIndex - 1;
      end;
    end else
    begin
      if lstMain.ItemIndex < (lstMain.Items.Count-1) then
      begin
        lstMain.ItemIndex := lstMain.ItemIndex + 1;
      end;
    end;
  end;
end;

procedure TfrmPandaTray.TrayOnLeftClick(Sender: TObject);
begin
  // Todo: TRAY.Left Click
  if not bTrayOpen then
  begin
    TrayShow;
  end else
  begin
    TrayHide;
  end;
end;

procedure TfrmPandaTray.TrayOnRightClick(Sender: TObject);
begin
  // todo: TRAY.Right Click
  // popsMain.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  // set size
  if frmMemo.Showing then
  begin
    frmMemo.Close;
  end else
  begin
    frmMemo.Left := Screen.WorkAreaRect.Right - frmMemo.Width;
    frmMemo.Top  := Screen.WorkAreaRect.Bottom - frmMemo.Height;
    frmMemo.Show;
    bCanClose := False;
    Close;
  end;
end;

procedure TfrmPandaTray.popCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmPandaTray.popsMainPopup(Sender: TObject);
begin
  // OʂɂȂƃ|bvAbvc
  Application.BringToFront;
  Self.BringToFront;
  // `FbN
  popClose.Visible := not bCanClose;
  popOpen.Visible  := bCanClose;

  // }`j^ǂ
  Screen.Monitors[0];
  if Screen.MonitorCount <= 1 then
  begin
    //popMultiMonitor.Enabled := False; // Ⴄ
    popMultiMonitor.Caption := '}`j^(ݖ)';
  end else
  begin
    //popMultiMonitor.Enabled := True; // }`j^gp
    popMultiMonitor.Caption := '}`j^';
  end;
end;

procedure TfrmPandaTray.popCompleteCloseClick(Sender: TObject);
begin
  bCanClose := True;
  Close;
end;

procedure TfrmPandaTray.popOpenClick(Sender: TObject);
begin
  TrayShow;
end;


const IID_IPersistFile: TGUID= (D1:$0000010B;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));

function ExtractStringFromLinkFile( Target:TFileName ): String;
var
    R   : HRESULT;
    SL  : IShellLink;
    PF  : IPersistFile;
    Wrk : array[0..MAX_PATH] of WideChar;
    Path: array[0..MAX_PATH] of Char;
    WFD : WIN32_FIND_DATA;
begin
    Result := '';
    CoInitialize( NIL );

    R := CoCreateInstance( CLSID_ShellLink, NIL, CLSCTX_INPROC_SERVER, IID_IShellLinkA, SL );
    if Succeeded( R ) then
    begin
        R := SL.QueryInterface( IID_IPersistFile, PF );
        if Succeeded( R ) then
        begin
            MultiByteToWideChar( CP_ACP, 0, PChar(Target), -1, Wrk, MAX_PATH );
            R := PF.Load( Wrk, STGM_READ );
            if Succeeded( R ) then
            begin
                R := SL.Resolve( 0{Application.Handle}, SLR_ANY_MATCH );
                if Succeeded( R ) then
                begin
                    SL.GetPath( Path, MAX_PATH, WFD, SLGP_SHORTPATH );
                    Result := Path;
                end;
            end;
        end;
        Result := ShortToLongFileName(Result);
    end;

    CoUninitialize;
end;

procedure TfrmPandaTray.fileDropFileDrop(Sender: TObject; Num: Integer;
  Files: TStrings; X, Y: Integer);
var
  row, id: Integer;
  i: Integer;
  s, n, ext: string;
begin
  // Add File
  for i := 0 to Files.Count - 1 do
  begin
    s := Files.Strings[i];
    if s = '' then Exit;

    n := ExtractFileName(s);
    ext := LowerCase(ExtractFileExt(n));

    // tH_̂Ƃ
    if DirectoryExists(s) then
    begin
      //n := '<' + n + '>';
    end;
    // TODO: N̂Ƃ
    if ext = '.lnk' then
    begin
      s := ExtractStringFromLinkFile(s);
      if s = '' then Exit;
      n := ExtractFileName(s);
    end;

    n := ChangeFileExt(n, '');
    id := csvList.getLastId(F_ID, 1);
    row := csvList.Count;
    csvList.Cells[ F_ID,       row ] := IntToStr(id);
    csvList.Cells[ F_NAME,     row ] := n;
    csvList.Cells[ F_FILENAME, row ] := s;
    csvList.Cells[ F_ICON,     row ] := '';
    csvList.Cells[ F_COUNT,    row ] := '1';
    csvList.Cells[ F_DATE,     row ] := DateTimeToStr(Now);
  end;
  csvList.TrimBottom;
  ListViewAll;
  ListSave;
  lstMain.ItemIndex := lstMain.Items.Count - 1;
end;

procedure TfrmPandaTray.AppEventDeactivate(Sender: TObject);
begin
  //TrayHide;
end;

procedure TfrmPandaTray.ListViewAll;
begin
  csvView.Assign(csvList);
  ListView;
end;

procedure TfrmPandaTray.ListExecute;
var
  i, ret, row: Integer;
  id, s: string;
begin
  i := lstMain.ItemIndex;
  if i < 0 then Exit;

  TrayHide;
  
  id := csvView.Cells[ F_ID,       i ];
  s  := csvView.Cells[ F_FILENAME, i ];

  if Args <> '' then
  begin
    s := Format('"%s" %s',[s, Args]);
    ret := WinExec(PChar(s), SW_SHOW);
    Args := '';
  end else
  begin
    SetCurrentDir(ExtractFilePath(s));
    ret := OpenApp(s);
  end;
  if ret <= 32 then
  begin
    // failed
    ShowMessage(msg_exec_failed);
    Beep;
    Exit;
  end;
  edtCommand.Text := '';

  // list
  row := csvList.FindStr(F_ID, id, 0);
  if i >= 0 then
  begin
    csvList.Cells[F_DATE,  row] := DateTimeToStr(Now);
    csvList.Cells[F_COUNT, row] := IntToStr(StrToIntDef(csvList.Cells[F_COUNT, row], 0) + 1);
    ListSave;
  end;
  ListViewAll;
end;

procedure TfrmPandaTray.edtCommandChange(Sender: TObject);
var
  s, c: string;
  i: Integer;
  cells: TCsvCells;
begin
  s := edtCommand.Text;
  if s = '' then
  begin
    ListViewAll;
    Exit;
  end;
  s := LowerCase(s);

  csvView.Clear;
  for i := 0 to csvList.Count - 1 do
  begin
    c := csvList.Cells[ F_NAME, i ];
    c := LowerCase(c);
    if Pos(s, c) > 0 then
    begin
      cells := TCsvCells.Create;
      cells.Assign(csvList.Rows[i]);
      csvView.AddRow(cells);
    end;
  end;

  ListView;
  lstMain.ItemIndex := lstMain.Items.Count - 1;
end;

procedure TfrmPandaTray.ListView;
var
  i: Integer;
  s: string;
begin
  csvView.TrimBottom;

  case sortType of
    stTime  : csvView.SortDate(F_DATE);
    stCount : csvView.SortNum(F_COUNT);
    stName  : csvView.SortStr(F_NAME);
  end;
  //csvView.ReverseRow;

  lstMain.Clear;
  for i := 0 to csvView.Count - 1 do
  begin
    s := csvView.Cells[F_NAME, i];
    lstMain.Items.Add(s);
  end;
  if lstMain.ItemIndex < 0 then
  begin
    lstMain.ItemIndex := lstMain.Items.Count - 1;
  end;
  lstMain.Invalidate;
end;

procedure TfrmPandaTray.hotkeyShowHotKeyPressed(HotKey: Cardinal;
  Index: Word);
var
  mon: TMonitor;
  x, y, ww, hh: Integer;
  r: TRect;
  wi: TWindowInfo;
  h, ph: THandle;
  perw, perh: Extended;
begin
  if hotkeyid_show = Index then
  begin
    if bTrayOpen then
      TrayHide
    else
    begin
      TrayShow;
      // ēxOʂ
      Application.ProcessMessages;
      Application.BringToFront;
      Self.BringToFront;
      edtCommand.SetFocus;
    end;
  end else
  if hotkeyid_restart = Index then
  begin
    mnuRestartLaunchClick(nil);
    Exit;    
  end else
  if hotkeyid_movecur = Index then
  begin
    Screen.Monitors[0];
    if Screen.MonitorCount <= 1 then Exit;
    mon := getNextMonitor(Mouse.CursorPos);
    x := mon.Left + mon.Width  div 2;
    y := mon.Top  + mon.Height div 2;
    SetCursorPos(x, y);
  end else
  if hotkeyid_movewin = Index then
  begin
    try
      Screen.Monitors[0];
      if Screen.MonitorCount <= 1 then Exit;
      // gbvx̃EBhE擾
      h := WindowFromPoint(Mouse.CursorPos);
      while True do
      begin
        ph := GetParent(h);
        if ph = 0 then Break;
        h := ph;
      end;
      if h = 0 then Exit;
      // EBhȄ擾
      if GetWindowInfo(h, wi) then
      begin
        // EBhEǂ̃j^ɂ邩ׂ
        r := wi.rcWindow;
        mon := Screen.MonitorFromPoint(wi.rcClient.TopLeft);
        x := r.Left - mon.Left;
        y := r.Top  - mon.Top;
        perw := (r.Right - r.Left) / (mon.WorkareaRect.Right - mon.WorkareaRect.Left);
        perh := (r.Bottom - r.Top) / (mon.WorkareaRect.Bottom - mon.WorkareaRect.Top);

        // ǂɈړ邩WvZ
        mon := getNextMonitor(mon.WorkareaRect.TopLeft);
        x := x + mon.Left;
        y := y + mon.Top;
        ww := Trunc((mon.WorkareaRect.Right - mon.WorkareaRect.Left) * perw);
        hh := Trunc((mon.WorkareaRect.Bottom- mon.WorkareaRect.Top ) * perh);
        if (x+ww) > mon.Width then
        begin
          x  := mon.Left;
          ww := mon.Width;
        end;
        if (y+hh) > mon.Height then
        begin
          y  := mon.Top;
          hh := mon.Height;
        end;
        ShowWindow(h, SW_SHOWNORMAL);
        SetWindowPos(h, 0, x, y, ww, hh, SWP_SHOWWINDOW);
        //MoveWindow(h, x, y, ww, hh, True);
        // Monitor Center
        x := mon.Left + mon.Width  div 2;
        y := mon.Top  + mon.Height div 2;
        SetCursorPos(x, y);
      end;
    except
    end;
  end;
end;

procedure TfrmPandaTray.edtCommandKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

  procedure _appendList;
  var
    i: Integer;
  begin
    i := csvList.Count;
    csvList.Cells[F_ID,       i] := IntToStr(csvList.getLastId(F_ID, 1));
    csvList.Cells[F_NAME,     i] := edtCommand.Text;
    csvList.Cells[F_FILENAME, i] := edtCommand.Text;
    csvList.Cells[F_DATE,     i] := DateTimeToStr(Now);
    ListSave;
    edtCommand.Text := '';
  end;

var
  ret: Integer;
  cmd: string;
begin
  if Key = VK_ESCAPE then
  begin
    TrayHide;
    Exit;
  end;

  if (Key = VK_DOWN)or(Key = VK_UP) then
  begin
    lstMain.SetFocus;
    if lstMain.Items.Count > 0 then
    begin
      lstMain.ItemIndex := lstMain.Items.Count - 1;
    end;
    Exit;
  end;

  if Key = VK_RETURN then
  begin
    if lstMain.Items.Count = 0 then
    begin
      cmd := edtCommand.Text;

      // todo: R}h
      if ExecCommandEx(cmd) then
      begin
        Exit;
      end else
      begin
        ret := OpenApp(cmd);
        if ret <= 32 then
        begin
          Beep;
          Exit;
        end;
        // m̃R}h
        // Xgɒǉ
        _appendList;
        TrayHide;
      end;
    end else
    begin
      if lstMain.Items.Count <= 1 then
      begin
        lstMain.ItemIndex := 0;
        ListExecute;
      end else
      begin
        lstMain.ItemIndex := lstMain.Items.Count - 1;
        lstMain.SetFocus;
      end;
    end;
    Key := 0;
  end;
end;

procedure TfrmPandaTray.btnConfClick(Sender: TObject);
begin
  //
  TrayOnRightClick(nil);
end;

procedure TfrmPandaTray.popInstallClick(Sender: TObject);
const
  msg_prepare = 'p肪Ƃ܂BCXg[ƂJn܂B';
  msg_startup = 'X^[gAbvɓo^܂H'#13#10'(WindowsNɎIɋN悤ɂȂ܂B)';
  msg_program = 'X^[gj[ׂ̂ẴNo^܂H';
  msg_addopt  = 'dǉ܂H';

  procedure _add(name, cmd: string);
  var
    i, id: Integer;
  begin
    i := csvList.FindStr(F_FILENAME, cmd, 0);
    if i >= 0 then Exit;
    i := csvList.Count;
    id := csvList.getLastId(F_ID, 1);
    csvList.Cells[F_ID,       i] := IntToStr(id);
    csvList.Cells[F_NAME,     i] := name;
    csvList.Cells[F_FILENAME, i] := cmd;
    csvList.Cells[F_DATE,     i] := DateTimeToStr(Now);
  end;

begin
  //if not MsgYesNo(msg_prepare) then Exit;
  if MsgYesNo(msg_startup) then
  begin
    CreateShortCut(StartUpDir + FILE_STARTUP,
      ParamStr(0),
      '',
      AppPath,
      wsNormal);
  end;
  if MsgYesNo(msg_addopt) then
  begin
    _add('calc',    SysDir + 'calc.exe');
    _add('notepad', WinDir + 'notepad.exe');
  end;
  ListSave;
  ListViewAll;
end;

procedure TfrmPandaTray.popEditItemClick(Sender: TObject);
var
  i: Integer;
begin
  i := lstMain.ItemIndex;
  with frmProp do
  begin
    if i < 0 then i := csvView.Count;
    EditID       := csvView.Cells[F_ID, i];
    edtName.Text := csvView.Cells[F_NAME, i];
    edtFile.Text := csvView.Cells[F_FILENAME, i];
    edtDate.Text := csvView.Cells[F_DATE, i];
    if edtDate.Text = '' then
    begin
      edtDate.Text := DateTimeToStr(Now);
    end;
  end;
  frmProp.Show;
end;

procedure TfrmPandaTray.lstMainDblClick(Sender: TObject);
begin
  ListExecute;
end;

procedure TfrmPandaTray.lstMainMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  row: Integer;
begin
  row := lstMain.ItemAtPos(Point(X,Y), True);
  lstMain.ItemIndex := row;

  if Button = mbRight then
  begin
    popsFile.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
  end else
  if Button = mbLeft then
  begin
    ListExecute;
  end;
end;

procedure TfrmPandaTray.ListSave;
begin
  csvList.SaveToFile(AppPath + FILE_LIST, nil, #9);
end;

procedure TfrmPandaTray.popAboutClick(Sender: TObject);
begin
  ShowMessage(MSG_ABOUT);
end;

procedure TfrmPandaTray.popAddItemClick(Sender: TObject);
begin
  // ȃCfbNX^ĕҏWs
  lstMain.ItemIndex := -1;
  popEditItemClick(nil);
end;

procedure TfrmPandaTray.popHelpClick(Sender: TObject);
begin
  OpenApp(FILE_README);
end;

procedure TfrmPandaTray.popHotKeyChangeClick(Sender: TObject);
var
  s: string;
  i: Integer;
begin
  s := InputBox('zbgL[','ύXzbgL[͂ĂB'#13#10+
  ') Ctrl + Shift + Alt + Q','');
  if s = '' then Exit;
  i := TextToHotKey(s, True);
  if i <= 0 then
  begin
    ShowMessage('Ȃgݍ킹łB'#13#10 + s);
    Exit;
  end;
  hotkeyid_show := hotkeyShow.ChangeHotKey(hotkeyid_show, i);
  ini.WriteString(INI_SEC_HOTKEY,INI_KEY_SHOW,s);
end;

procedure TfrmPandaTray.popOpenSetDirClick(Sender: TObject);
begin
  OpenApp(AppPath);
end;



procedure TfrmPandaTray.lstMainDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  cap, fname, id, icofile: string;
  bmp: TBitmap;
  iid: Integer;
  lb: TListBox;
  c: TCanvas;
  ico: TIcon;
  x, y: Integer;
const
  bgcolor: Array [0..1] of Integer = ($FFFFFF, $F0F0F0);
begin
  // OwnerDraw
  cap   := csvView.Cells[F_NAME, Index];
  fname := csvView.Cells[F_FILENAME, Index];
  id    := csvView.Cells[F_ID, Index];
  iid   := StrToIntDef(id, 0);
  //
  //cap := cap + '  : ' + csvView.Cells[F_DATE, Index];
  //
  lb := Control as TListBox;
  c  := lb.Canvas;
  //
  c.Brush.Style := bsSolid;
  c.Brush.Color := bgcolor[Index mod 2];
  c.Pen.Style   := psSolid;
  c.Pen.Width   := 1;
  c.Pen.Color   := c.Brush.Color;
  c.Font.Height := lb.Font.Height;
  c.Font.Color  := clBlack;

  // cursor?
  if odSelected in State then
  begin
    c.Brush.Color := clHighlight;
    c.Font.Color  := clHighlightText;
  end;

  c.Rectangle(Rect);
  x := Rect.Left + 3;
  y := Rect.Top + ((Rect.Bottom-Rect.Top) - 16) div 2;

  if (Pos('http://', fname)>0) or (Pos('https://', fname)>0) or
     (Copy(fname,1,2) = '\\') then
  begin
    c.Draw(x, y, imgWebIcon.Picture.Graphic);
  end else
  begin
    // check icon cache
    bmp := nil;
    icofile := AppPath + ICON_DIR + id + '.bmp';
    if iconList.Count > iid then
    begin
      if iconList.Items[iid] <> nil then
      begin
        bmp := iconList.Items[iid];
      end;
    end;
    // check icon file
    if bmp = nil then
    begin
      if FileExists(icofile) then
      begin
        bmp := TBitmap.Create;
        try
          bmp.LoadFromFile(icofile);
          if iconList.Count <= iid then iconList.Count := iid + 1;
          iconList.Items[iid] := bmp;
        except
          FreeAndNil(bmp);
        end;
      end;
    end;
    // check exe file
    if bmp = nil then
    begin
      if FileExists(fname) or DirectoryExists(fname) then
        ico := GetIconImage(fname)
      else
        ico := TIcon.Create;
      
      if iconList.Count <= iid then iconList.Count := iid + 1;
      bmp := TBitmap.Create;
      try
        bmp.PixelFormat := pf24bit;
        bmp.Width  := 16;
        bmp.Height := 16;
        if ico.Handle <> 0 then
        begin
          bmp.Canvas.Draw(0, 0, ico);
        end else begin
          bmp.Canvas.Draw(0, 0, imgDefIcon.Picture.Graphic);
        end;
        bmp.SaveToFile(icofile);
        iconList.Items[iid] := bmp;
      finally
      end;
      FreeAndNil(ico);
    end;
    try
      c.Draw(x, y, bmp);
    finally
    end;
  end;
  Inc(x, 16 + 3 * 2);

  y := Rect.Top + ((Rect.Bottom-Rect.Top) - c.TextHeight('w')) div 2;
  c.TextOut(x, y, cap);

end;

procedure TfrmPandaTray.lstMainKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_UP)or(Key = VK_DOWN) then
  begin
    Exit;
  end;
end;

procedure TfrmPandaTray.popDelItemClick(Sender: TObject);
var
  i: Integer;
  id: string;
begin
  i := lstMain.ItemIndex;
  if i < 0 then Exit;

  id := csvView.Cells[F_ID, i];
  if not MsgYesNo(
    'ȉ̃t@C폜܂H'#13#10 +
    csvView.Cells[F_NAME, i] + #13#10 +
    csvView.Cells[F_FILENAME, i]
  ) then begin
    Exit;
  end;

  // del from view
  csvView.DeleteRow(i);

  // del from
  i := csvList.FindStr(F_ID, id, 0);
  if i < 0 then Exit;
  csvList.DeleteRow(i);

  ListView;
  if i < lstMain.Items.Count then
  begin
    lstMain.ItemIndex := i;
  end;
  ListSave;
end;

procedure TfrmPandaTray.popCheckAndRemoveClick(Sender: TObject);
var
  i: Integer;
  s, fname, cap: string;
begin
  i := 0;
  while i < csvList.Count do
  begin
    fname := csvList.Cells[F_FILENAME, i];
    cap   := csvList.Cells[F_NAME, i];
    if
      (Pos(':\', fname) = 0) or
      (FileExists(fname)) or
      (DirectoryExists(fname)) then
    begin
      Inc(i); Continue;
    end;
    s := 'ȉ̃t@C݂͑܂B폜Ă낵łH'#13#10;
    s := s + cap + #13#10 + fname;
    if not MsgYesNo(s) then
    begin
      Inc(i); Continue;
    end;
    csvList.DeleteRow(i);
  end;
  ListSave;
  ListViewAll;
end;

procedure TfrmPandaTray.lstMainKeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = VK_ESCAPE) then
  begin
    edtCommand.SetFocus;
    Exit;
  end;
  if (Ord(Key) = VK_RETURN) then
  begin
    ListExecute;
  end;
end;

procedure TfrmPandaTray.popUninstallClick(Sender: TObject);
begin
  if not MsgYesNo('ACXg[Ă낵łH') then Exit;
  DeleteFile(StartUpDir + FILE_STARTUP);
  ShowMessage('I܂B');
  popCompleteCloseClick(nil);  
end;

procedure TfrmPandaTray.timerPanelTimer(Sender: TObject);
begin
  //timerPanel.Enabled := False;
  try
    Caption := S_CAPTION + ' ' + FormatDateTime('mm/dd(ddd) hh:nn:ss', Now);
    Application.Title := Caption;
  finally
    //timerPanel.Enabled := True;
  end;
end;

procedure TfrmPandaTray.popExecWithArgFileClick(Sender: TObject);
begin
  if not dlgOpen.Execute then Exit;
  Args := '"' + dlgOpen.FileName + '"';
  ListExecute;
end;

procedure TfrmPandaTray.popExecWithArgStrClick(Sender: TObject);
var
  s: string;
begin
  s := InputBox('ċN','w肵ĂB','');
  if s = '' then Exit;
  Args := s;
  ListExecute;
end;

procedure TfrmPandaTray.popLaunchEditNoteClick(Sender: TObject);
begin
  TrayHide;
  RunAppAndWait('', 'notepad.exe "'+AppPath+FILE_LIST+'"');
  csvList.LoadFromFile(AppPath + FILE_LIST, nil, #9);
  ListViewAll;
  TrayShow;
end;

procedure TfrmPandaTray.popChangeTrayIconClick(Sender: TObject);
var
  ico: TIcon;
begin
  // w
  dlgOpen.Filter := 'icon|*.ico;*.bmp';
  try
    if not dlgOpen.Execute then Exit;
    ico := TIcon.Create;
    try
      ico.LoadFromFile(dlgOpen.FileName);
      ini.WriteString('icon','tasktray',dlgOpen.FileName);
      tray.ChangeIcon(ico);
    except
      ShowWarn('ACR`ƂĔFł܂I','ACR̎w');
      Exit;
    end;
    FreeAndNil(ico);
  finally
    dlgOpen.Filter := '*.*|*.*';
  end;
end;

procedure TfrmPandaTray.popSortTimeClick(Sender: TObject);
begin
  sortType := stTime;
  ini.WriteString('launch','sort','time');
  ListView;
end;

procedure TfrmPandaTray.popSortCountClick(Sender: TObject);
begin
  sortType := stCount;
  ini.WriteString('launch','sort','count');
  ListView;
end;

procedure TfrmPandaTray.popSortNameClick(Sender: TObject);
begin
  sortType := stName;
  ini.WriteString('launch','sort','name');
  ListView;
end;

function TfrmPandaTray.Str2SortType(s: string): TPandaSortType;
var
  sortType: TPandaSortType;
begin
  if s = 'time'  then begin popSortTime.Checked  := True; sortType := stTime;  end else
  if s = 'count' then begin popSortCount.Checked := True; sortType := stCount; end else
  if s = 'name'  then begin popSortName.Checked  := True; sortType := stName;  end else
  begin
    sortType := stTime;
  end;
  Result := sortType;
end;

procedure TfrmPandaTray.popHotKeyMoveCurClick(Sender: TObject);
var
  s: string;
  key: DWORD;
begin
  s := ini.ReadString(INI_SEC_HOTKEY,INI_KEY_MOVECUR,'');
  s := InputBox('j^Ԃ̃J[\szbgL[w','zbgL[w肵ĂB'#13#10+
    'LZw肷Ɨp܂B',s);

  if s = '' then
  begin
    if hotkeyid_movecur > 0 then
    begin
      hotkeyShow.RemoveHotKeyByIndex(hotkeyid_movecur);
    end;
    popHotKeyMoveCur.Caption := 'J[\ړL[̐ݒ';
  end else begin
    key := TextToHotKey(s, True);
    if hotkeyid_movecur = 0 then
    begin
      hotkeyid_movecur := hotkeyShow.AddHotKey(key);
    end else
    begin
      hotkeyid_movecur := hotkeyShow.ChangeHotKey(hotkeyid_movecur, key);
    end;
    popHotKeyMoveCur.Caption := 'J[\ړL[[' + s + ']̕ύX';
  end;

  ini.WriteString(INI_SEC_HOTKEY, INI_KEY_MOVECUR, s);
end;

function TfrmPandaTray.getNextMonitor(CurPos: TPoint): TMonitor;
var
  mon: TMonitor;
  i, idx: Integer;
begin
  
  if Screen.MonitorCount <= 1 then
  begin
    Result := Screen.Monitors[0];
    Exit;
  end;

  mon := Screen.MonitorFromPoint(CurPos, mdNearest);
  idx := -1;
  for i := 0 to Screen.MonitorCount - 1 do
  begin
    if Screen.Monitors[i].MonitorNum = mon.MonitorNum then
    begin
      idx := i;
      Break;
    end;
  end;
  Inc(idx);
  if idx >= Screen.MonitorCount then idx := 0;
  mon := Screen.Monitors[idx];
  Result := mon;
end;

procedure TfrmPandaTray.popHotkeyMoveWinClick(Sender: TObject);
var
  s: string;
  key: DWORD;
begin
  s := ini.ReadString(INI_SEC_HOTKEY,INI_KEY_MOVEWIN,'');
  s := InputBox('ANeBuEBhEړzbgL[w','zbgL[w肵ĂB'#13#10+
    'LZw肷ƃzbgL[܂B',s);

  if s = '' then
  begin
    if hotkeyid_movewin > 0 then
    begin
      hotkeyShow.RemoveHotKeyByIndex(hotkeyid_movewin);
    end;
    popHotKeyMoveWin.Caption := 'ANeBuEBhEړL[̐ݒ';
  end else begin
    key := TextToHotKey(s, True);
    if hotkeyid_movewin = 0 then
    begin
      hotkeyid_movewin := hotkeyShow.AddHotKey(key);
    end else
    begin
      hotkeyid_movewin := hotkeyShow.ChangeHotKey(hotkeyid_movecur, key);
    end;
    popHotKeyMoveWin.Caption := 'ANeBuEBhEړL[[' + s + ']̕ύX';
  end;
  ini.WriteString(INI_SEC_HOTKEY, INI_KEY_MOVEWIN, s);
end;

procedure TfrmPandaTray.edtCommandKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then Key := #0;
end;

procedure TfrmPandaTray.mnuOpenTargetDirClick(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  i := lstMain.ItemIndex;
  if i < 0 then Exit;
  s := csvView.Cells[F_FILENAME, i];
  s := ExtractFilePath(s);
  OpenApp(s);
end;

procedure TfrmPandaTray.mnuRestartLaunchClick(Sender: TObject);
begin
  bCanClose := True;
  OpenApp(ParamStr(0));
  Close;
end;

function TfrmPandaTray.ExecCommandEx(cmd: string): Boolean;
begin
  //TrueԂ
  //todo: R}h
  Result := True;
  if cmd = 'restart' then
  begin
    mnuRestartLaunchClick(nil);
    Exit;
  end;
  Result := False;
end;

procedure TfrmPandaTray.popHotkeyRestartClick(Sender: TObject);
var
  s: string;
  key: DWORD;
begin
  s := ini.ReadString(INI_SEC_HOTKEY,INI_KEY_RESTART,'');
  s := InputBox('gċNzbgL[̎w','zbgL[w肵ĂB'#13#10+
    'LZw肷Ɨp܂B',s);

  if s = '' then
  begin
    if hotkeyid_restart > 0 then
    begin
      hotkeyShow.RemoveHotKeyByIndex(hotkeyid_restart);
    end;
    popHotkeyRestart.Caption := 'gċNL[̐ݒ';
  end else begin
    key := TextToHotKey(s, True);
    if hotkeyid_restart = 0 then
    begin
      hotkeyid_restart := hotkeyShow.AddHotKey(key);
    end else
    begin
      hotkeyid_restart := hotkeyShow.ChangeHotKey(hotkeyid_restart, key);
    end;
    popHotkeyRestart.Caption := 'J[\ړL[[' + s + ']̕ύX';
  end;

  ini.WriteString(INI_SEC_HOTKEY, INI_KEY_RESTART, s);
end;

procedure TfrmPandaTray.IconListClear;
var
  i: Integer;
  icon: TBitmap;
begin
  for i := 0 to iconList.Count-1 do
  begin
    icon := iconList.Items[i];
    if icon <> nil then
    begin
      FreeAndNil(icon);
    end;
    iconList.Items[i] := nil;
  end;
end;

procedure TfrmPandaTray.mnuClearIconCacheClick(Sender: TObject);
var
  i: Integer;
  g: TStringList;
begin
  IconListClear;
  g := getAllFiles(AppPath + ICON_DIR + '*.bmp');
  try
    for i := 0 to g.Count-1 do
    begin
      DeleteFile(g.Strings[i]);
    end;
  finally
    FreeAndNil(g);
  end;
end;

procedure TfrmPandaTray.mnuOpenSendToClick(Sender: TObject);
begin
  OpenApp(SendToDir);
end;

procedure TfrmPandaTray.mnuOpenCalcClick(Sender: TObject);
begin
  OpenApp('calc.exe');
end;

procedure TfrmPandaTray.mnuPandaTrayWebClick(Sender: TObject);
begin
  OpenApp('http://kujirahand.com/tools/panda_tray/');
end;

end.
