unit CsvUtils2Grid;

interface
uses
  CsvUtils2, grids;

// Obh񕝂̎
procedure CsvGridAutoColWidth(grid: TDrawGrid; csv: TCsvSheet);
// ObhɃf[^𒍓
procedure CsvGridSetData(grid: TStringGrid; csv: TCsvSheet);
// Obhɂ
procedure CsvGridClearGrid(grid: TStringGrid);
// Obhf[^𓾂
procedure CsvGridGetData(grid: TStringGrid; csv: TCsvSheet);

implementation

// Obhf[^𓾂
procedure CsvGridGetData(grid: TStringGrid; csv: TCsvSheet);
var
  c, r: Integer;
begin
  csv.Clear;
  for r := 0 to grid.RowCount - 1 do
  begin
    for c := 0 to grid.ColCount - 1 do
    begin
      csv.Cells[c, r] := grid.Cells[c, r];
    end;
  end;
end;

procedure CsvGridAutoColWidth(grid: TDrawGrid; csv: TCsvSheet);
var
  cols, rows: Integer;

  procedure SetWidth;
  var
    x, y, w, ww: Integer;
    v: string;
  begin
    // grid ̃TCY킹
    if rows > 100 then rows := 100;
    for x := 0 to cols - 1 do
    begin
      w := 0;
      for y := 0 to rows - 1 do
      begin
        v := csv.Cells[x, y];
        ww := grid.Canvas.TextWidth(v);
        if w < ww then w := ww;
      end;
      w := Trunc(w * 1.2);
      if grid.Width < w then w := grid.Width div 3;
      if w < grid.DefaultColWidth then w := grid.DefaultColWidth;
      grid.ColWidths[x + grid.FixedCols] := w;
    end;
  end;

begin
  cols := csv.ColCount ;
  rows := csv.Count ;

  with grid do
  begin
    Canvas.Font := Font;
    RowCount := rows + 1;
    ColCount := cols + FixedCols ;
    DefaultRowHeight := Trunc(grid.Canvas.TextHeight('A')*1.2);
    SetWidth;
    Invalidate ;
  end;
end;

// Obhɂ
procedure CsvGridClearGrid(grid: TStringGrid);
var
  x, y: Integer;
begin
  // Clear
  for y := 0 to grid.RowCount - 1 do
  begin
    for x := 0 to grid.ColCount - 1 do
    begin
      grid.Cells[x, y] := '';
    end;
  end;
end;


// ObhɃf[^𒍓
procedure CsvGridSetData(grid: TStringGrid; csv: TCsvSheet);
var
  x, y, cols: Integer;
begin
  // set csv
  cols := csv.ColCount ;
  grid.ColCount := cols + grid.FixedCols;
  grid.RowCount := csv.Count + 1;
  CsvGridClearGrid(grid);

  for y := 0 to csv.Count - 1 do
  begin
    for x := 0 to cols - 1 do
    begin
      grid.Cells[x + grid.FixedCols, y] := csv.Cells[x, y];
    end;
  end;
end;


end.
