unit unit_geticon;

interface
uses
  SysUtils, Classes, CsvUtils2, Graphics, shellapi, Windows;

type
  TIconList = class(TList)
  private
    procedure SetIcon(Index: Integer; const Value: TIcon);
  public
    function GetIcon(Index: Integer): TIcon;
    property Icons[Index: Integer]: TIcon read GetIcon write SetIcon;
  end;

function GetIconImage(fname: string): TIcon;

implementation

function GetIconImage(fname: string): TIcon;
var
  ico: TIcon;
  shfi: SHFILEINFO;
  res: DWORD;
begin
  // ACR𓾂
  ico := TIcon.Create ;
  try
    // icon 16
    res := SHGetFileInfo(
      PChar(fname),
      FILE_ATTRIBUTE_ARCHIVE, shfi, SizeOf(shfi),
      SHGFI_ICON or SHGFI_SMALLICON);
    ico.Handle := shfi.hIcon;
    if res = 0 then
    begin
    end;
    (*
    bmp.Width  := 16;
    bmp.Height := 16;
    bmp.PixelFormat := pf24bit ;
    bmp.Canvas.Draw(0,0,ico);
    bmp.SaveToFile(GetDataPath + 'small-' + id + '.bmp');
    bmp.Free;
    bmp := TBitmap.Create ;
    *)
  finally
    Result := ico;
  end;
end;

{ TIconList }

function TIconList.GetIcon(Index: Integer): TIcon;
begin
  Result := Items[Index];
end;

procedure TIconList.SetIcon(Index: Integer; const Value: TIcon);
begin
  Items[Index] := Value;
end;

end.
